/************************************************
**** ELEM:                                   ****
**** classe che implementa i singoli         ****
**** elementi dello heap di Fibonacci.       ****
****                                         ****
**** Larcheri Paolo       52 SI              ****
************************************************/

#include "Elem.h"

/* COSTRUTTORE E DISTRUTTORE */

Elem::Elem(long int c) {
  this->chiave = c;      /* valore dell'elemento */
  this->grado = 0;       /* numero dei suoi figli */
  this->marcato = 0;     /* indica se il e' nodo marcato -> ha perso 
			   un figlio in un certo arco di tempo */
  this->padre = NULL;    /* puntatore al padre */
  this->figli = NULL;    /* puntatore al primo figlio */
  this->destro = NULL;   /* puntatore al fratello destro */
  this->sinistro = NULL; /* puntatore al fratello sinistro */
}

Elem::~Elem() {
}


/* METODI CHE RITORNANO I VARI ATTRIBUTI */ 

long int Elem::getChiave() {
  return this->chiave;
}

int Elem::getGrado() {
  return this->grado;
}

int Elem::isMarked() {
  return this->marcato;
}

Elem* Elem::getPadre() {
  return this->padre;
}

Elem* Elem::getFigli() {
  return this->figli;
}

Elem* Elem::getDestro() {
  return this->destro;
}
    
Elem* Elem::getSinistro() {
  return this->sinistro;
}

/* METODI CHE 'SETTANO' I VARI ATTRIBUTI */

void Elem::setChiave(long int c) {
  (this->chiave) = c;
}

void Elem::setGrado(int g) {
  (this->grado) = g;
}

void Elem::mark() {
  (this->marcato) = 1;
}
 
void Elem::unmark(){
  (this->marcato) = 0;
}

void Elem::setPadre(Elem *p) {
  (this->padre) = p;
}

void Elem::setFigli(Elem *f) {
  (this->figli) = f;
}
    
void Elem::setDestro(Elem *d) {
  (this->destro) = d;
}

void Elem::setSinistro(Elem *s) {
  (this->sinistro) = s;
}
