/************************************************
**** FIBHEAP:                                ****
**** classe che implementa gli heap          ****
**** di Fibonacci                            ****
****                                         ****
**** Larcheri Paolo       52 SI              ****
************************************************/

#include "Elem.h"
#include <math.h>
#include <string.h>

class FibHeap {

  private:
  
    Elem *testa;                /* puntatore alla prima radice */
    Elem *min;                  /* puntatore all'elemento con chiave minima */ 
    
    int num_nodi;              
    int num_alberi;
    int num_marcati;
    
    /* metodi di settaggio */
    void setTesta(Elem*);
    void setMin(Elem*);
    void setNum_nodi(int);
    void setNum_alberi(int);
    void setNum_marcati(int);
    
    /* metodi ausliari */
    void consolidate();
    void link(Elem*, Elem*);
    void cut(Elem*, Elem*);
    void cascadingCut(Elem*);
    
  public:
  
    /* costruttore e distruttore */
    FibHeap();
    ~FibHeap();
    
    /* metodi che ritornano i vari attributi */
    Elem* getTesta();
    int getNum_nodi();
    int getNum_alberi();
    int getNum_marcati(); 
      
    /* metodi fondamentali della classe */  
    void insert(long int);
    Elem* getMin();
    void unify(FibHeap **);
    Elem* extractMin();
    int decreaseKey(Elem*, long int);
    void reset();
};
