/**************************************/
/********LARHCERI PAOLO 52SI***********/
/**************************************/
/* NB: la classe template deve avere gli operatori di
   confronto (<, >). */

#include <stdlib.h>
#define ELEM



template <class T>
class Elem {

  private:
    
    T chiave;  /* chiave dell'arco */
    int nodo1; /* nodo appartenente al MOMENTANEO minimum spanning tree */
    int nodo2; /* nodo esterno al MOMENTANEO minimum spanning tree */
    int grado;      /* numero di figli */
    int marcato;    /* indica se il nodo e' marcato */
    
    Elem<T> *padre;    /* punta al nodo-padre */ 
    Elem<T> *figli;    /* punta alla lista dei figli */
    Elem<T> *destro;   /* punta al prossimo elemento a destra */
    Elem<T> *sinistro; /* punta al prossimo elemento a sinistra */
    
  public:
    
    Elem(T ch, int n1, int n2){
        this->chiave = ch;        /* chiave dell'arco */
        this->nodo1 = n1;
        this->nodo2 = n2;
        this->grado = 0;       /* numero dei suoi figli */
        this->marcato = 0;     /* indica se il e' nodo marcato -> ha perso 
			          un figlio in un certo arco di tempo */
        this->padre = NULL;    /* puntatore al padre */
        this->figli = NULL;    /* puntatore al primo figlio */
        this->destro = NULL;   /* puntatore al fratello destro */
        this->sinistro = NULL; /* puntatore al fratello sinistro */
    };
    
    ~Elem(){};
    
    T getChiave() {
       return this->chiave;
    };
    
    int getNodo1() {
       return this->nodo1;
    };
    
    int getNodo2() {
       return this->nodo2;
    };
    
    int getGrado() {
       return this->grado;
    };
    
    int isMarked() {
       return this->marcato;
    };
    
    Elem<T> *getPadre(){
       return this->padre;
    };
    
    Elem<T> *getFigli() {
       return this->figli;
    };
    
    Elem<T> *getDestro() {
       return this->destro;
    };
    
    Elem<T> *getSinistro() {
       return this->sinistro;
    };
    
    void setChiave(T ch) {
       (this->chiave) = ch;
    };
    
    void setNodo1(int n1) {
      (this->nodo1) = n1;
    }
    
    void setNodo2(int n2) {
       (this->nodo2) = n2;
    }
    
    void setGrado(int g) {
       (this->grado) = g;
    }
    
    void setPadre(Elem<T>* p) {
      (this->padre) = p;       
    }
    
    void setFigli(Elem<T>* f){
       (this->figli) = f; 
    }
    
    void setDestro(Elem<T> *d) {
       (this->destro) = d;
    }
    
    void setSinistro(Elem<T> *s) {
       (this->sinistro) = s;   
    }
    
    void mark() {
       (this->marcato) = 1;
    }
    
    void unmark() {
        (this->marcato) = 0;
    }
};
