#include "Prim.h"
#include <stdlib.h>
#include <unistd.h>
#include <list>
#include <time.h> 

Prim::Prim(Grafo<int>* g) {
  int i;
  
  G = g;
  // FibHeap<int>* FH;
  FH = new FibHeap<int>();
  cout << g->getNum_nodi() << endl;
  pb = new ProgressBar("Sto calcolando il minimo albero di copertura:", g->getNum_nodi(), 1, 20, '#');
  scelti = (bool*)malloc(G->getMax_num_nodi() * sizeof(bool));    
  FHtracer = (Elem<int>**)malloc(G->getMax_num_nodi() * sizeof(Elem<int>*));
  for (i=0; i<(G->getMax_num_nodi()); i++) {
    scelti[i] = false;
    FHtracer[i] = NULL;
  } 
}

Prim::~Prim() {
  free(scelti);
  free(FHtracer);
}


Grafo<int>* Prim::minSpanningTree() {
  Grafo<int>* MST = new Grafo<int>();
  Elem<int>* E;
  bool foto;
  char *buf = (char*)malloc(64*sizeof(char)); 
  int in_tree, index, j, i=0;
  list<Nodo_Nodo*> *ad_list = G->getAdiac_list();
  list<Nodo_Nodo*>::iterator it;
  
  foto = ((G->getNum_nodi()) <= 50);
  system("rm *.gif &> /dev/null");
     
  srand(time(NULL));
  /* SCELGO UN NODO A CASO DA CUI PARTIRE... */
  do {
   in_tree = rand()%G->getNum_nodi();
  }  while(!G->esisteNodo(in_tree));
  scelti[in_tree] = true;
  printf("Nodo di partenza: %d\n", in_tree);
  sleep(2);
  
  /* ...E INSERISCO TUTTI I SUOI ARCHI NELLO HEAP */
  for(it=ad_list[in_tree].begin(); it!=ad_list[in_tree].end(); it++)
     FHtracer[(*it)->getNodo()] = FH->insert(in_tree, (*it)->getNodo(), (*it)->getPeso());
  pb->Advance();
  /* SALVO LA PRIMA FOTO */       
  if(foto) {
    i++;
    sprintf(buf,"aa0%d.dot", i);
    G->saveDotFile(buf, MST, scelti, FHtracer);
  }
    
  while ((E = (FH->extractMin())) != NULL) {
    in_tree = E->getNodo2();
    MST->insArco(in_tree, E->getNodo1(), E->getChiave());
    FHtracer[in_tree] = NULL;
    scelti[in_tree] = true;
    for(it=ad_list[in_tree].begin(); it!=ad_list[in_tree].end(); it++) 
      if(!MST->esisteNodo((*it)->getNodo())) {
        if (FHtracer[(*it)->getNodo()] == NULL) 
           FHtracer[(*it)->getNodo()] = FH->insert(in_tree, (*it)->getNodo(), (*it)->getPeso());    
        else {
           j = FH->decreaseKey(FHtracer[(*it)->getNodo()], in_tree, (*it)->getPeso());  
	}
    }
    
    pb->Advance();
    if(foto) {
      i++;
      if(i>=10)
       sprintf(buf,"aa%d.dot", i);
      else
       sprintf(buf,"aa0%d.dot", i);
      G->saveDotFile(buf, MST, scelti, FHtracer);
    }
  }    
  return MST;
}
