#include "Prim.h"
#include <iostream.h>
#include <stdlib.h>
#include "Menu.h"

void setMainMenu();
void gestioneScelta(int);
void gestioneGrafoRandom();
void gestioneMinSpanningTree();
void gestioneVisualizzazione();
void gestioneVisualizzazioneMST();
void gestioneLoadFile();
void gestioneSaveFile();
int getInt();

Menu *main_menu = new Menu("MENU PRINCIPALE:");
Grafo<int> *t, *g = new Grafo<int>();
  
int main() { 
  int scelta;
  
  setMainMenu();
  while(1) {
    scelta = main_menu->select();
    gestioneScelta(scelta);
  }
}


void setMainMenu() {
  main_menu->addOpt("GENERA GRAFO CASUALE");
  main_menu->addOpt("VISUALIZZA GRAFO CORRENTE");
  main_menu->addOpt("TROVA MIN SPANNING TREE");
  main_menu->addOpt("CARICA GRAFO DA FILE");
  main_menu->addOpt("SALVA GRAFO SU FILE");
  main_menu->addOpt("ESCI------------------>");
}

void gestioneScelta(int sc) {
  switch (sc) {
    case 1:
       gestioneGrafoRandom();
       break;
    case 2:
       gestioneVisualizzazione();
       break;
    case 3:
       gestioneMinSpanningTree();
       break; 
    case 4:
       gestioneLoadFile();
       break; 
    case 5:
       gestioneSaveFile();
       break; 
    case 6:
       system("rm *.gif &> /dev/null");
       exit(0);
  }
}

void gestioneGrafoRandom() {
  int nn, na;
  
  do {
    cout << "INSERISCI numero dei NODI: ";
    nn = getInt();
    cout << "INSERISCI numero degli ARCHI: ";
    na = getInt();  
  } while(!g->randCreate(nn, na));
}

void gestioneVisualizzazione() {
  if(g->getNum_nodi() == 0) {
    cout << ":( Attuale grafo VUOTO!\n";
    return; 
  } 
  g->saveDotFile("temp", NULL, NULL, NULL);
  system("ee temp.gif");
  system("rm temp.gif");
}

void gestioneMinSpanningTree() {
  Prim *p = new Prim(g);
    
  t = p->minSpanningTree();
  if(g->getNum_nodi() <= 50) {
    cout << "ATTENDERE caricamento immagini...\n";
    system("ee *.gif");
    system("rm *.gif");
  }
}

void gestioneLoadFile() {
  char buff[60];
  
  cout << "Inserire nome del file da caricare:";
  cin >> buff;
  if (g->loadFile(buff))
    cout << ":) CARICATO correttamente!\n\n";
  else
    cout << ":( ERRORE: impossibile apripre il file!\n\n";
    
}

void gestioneSaveFile() {
  char buff[60];
  
  cout << "Inserire nome del file su cui salvare:";
  cin >> buff;
  if (g->saveFile(buff))
    cout << ":) SALVATO correttamente!\n\n";
  else
    cout << ":( ERRORE: impossibile apripre il file!\n\n";
    
}

int getInt() {
  int intero;
  bool prima_volta = true;
  char *integer, numero[50], **endptr = (char**)malloc(sizeof(char*));
  
  do {
    if(!prima_volta) {
      prima_volta = true;
      cout << "ERRORE: richiesto linserimento di un numero!\n";
    }
    cin >> numero;
    integer = strtok(numero, " \t\r.,");
    intero = strtol(integer, endptr, 10);
  } while (**endptr != '\0');    
  return intero;
}
